package gw.beans;

import gw.queue.Consumer;

import javax.ejb.Stateless;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.management.MBeanServerConnection;
import javax.management.ObjectName;
import javax.naming.Context;
import javax.naming.InitialContext;


@Stateless
public class RouterBean implements Router {


	private static Connection conn = null;
	private static Session session = null;
	private static Queue queue = null;
	
	static{
		try{
			System.out.println("Starting GW Core Service");
			
			String qname = "GW-Test";
			
			
			Context ctx2 = new InitialContext();
			
			
			MBeanServerConnection mbs = (MBeanServerConnection) ctx2.lookup("jmx/invoker/RMIAdaptor");
			
			
			ObjectName destinationManager = new ObjectName("org.hornetq:module=JMS,type=Server");
			
			
			mbs.invoke(destinationManager, "createQueue", new Object[] { qname, qname }, new String[] {
					String.class.getName(), String.class.getName() });
			
			try {
				System.out.println("Trying to connect to queue");
				
				Context ctx = new InitialContext();
				
				ConnectionFactory factory = null;
				while(true){
					try{
						factory = (ConnectionFactory) ctx.lookup("ConnectionFactory");
					}catch (Exception e) {
						System.out.println("FAIL to get connectionFactory");
						Thread.sleep(1000);
						continue;
					}
					break;
				}
				
				conn = factory.createConnection();

				session = conn.createSession(false, Session.AUTO_ACKNOWLEDGE);
				
				
				queue = (Queue) ctx.lookup(qname);
				
				
				MessageConsumer receiver = session.createConsumer(queue);
				receiver.setMessageListener(new Consumer());

				conn.start();
				System.out.println("New consumer started for queue: " + qname);
				
				System.out.println("DONE");
			} catch (Exception e) {
				e.printStackTrace();
				System.err.println("FAILED, reason: " + e.getMessage());
			}
			
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	
	public void processMessage(Message message){
		System.out.println("Test message from gw.beans.RouterBean");
	}
}
